<template>
  <div>
    <input
      class="inline border mb-1"
      v-model="model.name"
      @keyup="helper(updateCallback)"
      placeholder="Title" type="text"
    >
    <button
      class="inline border mb-1 px-1"
      @click.prevent="helper(addCallback)"
    >
      Add Sub Task
    </button>
    <button
      class="inline border mb-1 px-1"
      @click.prevent="helper(removeCallback)"
    >
      Remove
    </button>

    <objective-form
      class="ml-4"
      v-for="child in objective.objectives"
      :key="Math.random()"
      :objective="child"
      :parent="objective"
      :helper="helper"
    />
  </div>
</template>

<script lang="ts">
  import Vue from 'vue'
  import { IHasObjectives, Objective } from '~/utils/models'

  export default Vue.extend({
    name: 'ObjectiveForm',
    props: {
      objective: {
        type: Object as () => Objective,
        default: new Objective()
      },
      parent: {
        type: Object as () => IHasObjectives,
        default: new Objective()
      },
      helper: {
        type: Function,
        default: () => {}
      },
    },

    data () {
      const model = Object.assign({}, this.objective)

      return {
        model
      }
    },

    methods: {
      addCallback () {
        this.objective.objectives.push(new Objective())
      },

      updateCallback () {
        this.objective.name = this.model.name
      },

      removeCallback () {
        this.parent.objectives.splice(this.parent.objectives.indexOf(this.objective), 1)
      }
    }
  })
</script>
